Index: /trunk/gui/apps/about.in
===================================================================
--- /trunk/gui/apps/about.in	(revision 2788)
+++ /trunk/gui/apps/about.in	(revision 2789)
@@ -22,5 +22,5 @@
 dir=`dirname $0` ; \
 . $dir/rappture.env ; \
-exec wish "$0" $*
+exec wish "$0" "$@"
 # ----------------------------------------------------------------------
 # wish executes everything from here on...
Index: /trunk/gui/apps/encodedata.in
===================================================================
--- /trunk/gui/apps/encodedata.in	(revision 2788)
+++ /trunk/gui/apps/encodedata.in	(revision 2789)
@@ -9,5 +9,5 @@
 # ======================================================================
 #\
-exec wish "$0" $*
+exec wish "$0" "$@"
 
 package require Rappture
Index: /trunk/gui/apps/flowvis-test
===================================================================
--- /trunk/gui/apps/flowvis-test	(revision 2788)
+++ /trunk/gui/apps/flowvis-test	(revision 2789)
@@ -19,5 +19,5 @@
 bindir=`dirname $0` ; \
 . $bindir/rappture.env ; \
-exec wish "$0" $*
+exec wish "$0" "$@"
 # ----------------------------------------------------------------------
 # wish executes everything from here on...
Index: /trunk/gui/apps/nanovis-test
===================================================================
--- /trunk/gui/apps/nanovis-test	(revision 2788)
+++ /trunk/gui/apps/nanovis-test	(revision 2789)
@@ -19,5 +19,5 @@
 #\
 bindir=`dirname $0` ; \
-exec $bindir/wish "$0" $*
+exec $bindir/wish "$0" "$@"
 # ----------------------------------------------------------------------
 # wish executes everything from here on...
Index: /trunk/gui/apps/rappture.in
===================================================================
--- /trunk/gui/apps/rappture.in	(revision 2788)
+++ /trunk/gui/apps/rappture.in	(revision 2789)
@@ -16,3 +16,3 @@
 dir=`dirname $0`
 . $dir/rappture.env
-exec tclsh $dir/launcher.tcl $*
+exec tclsh $dir/launcher.tcl "$@"
Index: /trunk/gui/apps/rerun.in
===================================================================
--- /trunk/gui/apps/rerun.in	(revision 2788)
+++ /trunk/gui/apps/rerun.in	(revision 2789)
@@ -32,3 +32,3 @@
 dir=`dirname $0`
 . $dir/rappture.env
-exec $dir/rappture -nosim true -load $*
+exec $dir/rappture -nosim true -load "$@"
Index: /trunk/gui/apps/simsim.in
===================================================================
--- /trunk/gui/apps/simsim.in	(revision 2788)
+++ /trunk/gui/apps/simsim.in	(revision 2789)
@@ -11,5 +11,5 @@
 dir=`dirname $0` ; \
 . $dir/rappture.env ; \
-exec $dir/tclsh "$0" $*
+exec $dir/tclsh "$0" "$@"
 
 package require Rappture
Index: /trunk/gui/apps/vtkcontour-test
===================================================================
--- /trunk/gui/apps/vtkcontour-test	(revision 2788)
+++ /trunk/gui/apps/vtkcontour-test	(revision 2789)
@@ -19,5 +19,5 @@
 #\
 bindir=`dirname $0` ; \
-exec $bindir/wish "$0" $*
+exec $bindir/wish "$0" "$@"
 # ----------------------------------------------------------------------
 # wish executes everything from here on...
Index: /trunk/gui/apps/vtkheightmap-test
===================================================================
--- /trunk/gui/apps/vtkheightmap-test	(revision 2788)
+++ /trunk/gui/apps/vtkheightmap-test	(revision 2789)
@@ -19,5 +19,5 @@
 #\
 bindir=`dirname $0` ; \
-exec $bindir/wish "$0" $*
+exec $bindir/wish "$0" "$@"
 # ----------------------------------------------------------------------
 # wish executes everything from here on...
Index: /trunk/gui/apps/vtkstreamlines-test
===================================================================
--- /trunk/gui/apps/vtkstreamlines-test	(revision 2788)
+++ /trunk/gui/apps/vtkstreamlines-test	(revision 2789)
@@ -19,5 +19,5 @@
 #\
 bindir=`dirname $0` ; \
-exec $bindir/wish "$0" $*
+exec $bindir/wish "$0" "$@"
 # ----------------------------------------------------------------------
 # wish executes everything from here on...
Index: /trunk/gui/apps/vtkviewer-test
===================================================================
--- /trunk/gui/apps/vtkviewer-test	(revision 2788)
+++ /trunk/gui/apps/vtkviewer-test	(revision 2789)
@@ -19,5 +19,5 @@
 #\
 bindir=`dirname $0` ; \
-exec $bindir/wish "$0" $*
+exec $bindir/wish "$0" "$@"
 # ----------------------------------------------------------------------
 # wish executes everything from here on...
Index: /trunk/gui/apps/vtkvolume-test
===================================================================
--- /trunk/gui/apps/vtkvolume-test	(revision 2788)
+++ /trunk/gui/apps/vtkvolume-test	(revision 2789)
@@ -19,5 +19,5 @@
 #\
 bindir=`dirname $0` ; \
-exec $bindir/wish "$0" $*
+exec $bindir/wish "$0" "$@"
 # ----------------------------------------------------------------------
 # wish executes everything from here on...