Index: /trunk/packages/vizservers/nanovis/Command.cpp
===================================================================
--- /trunk/packages/vizservers/nanovis/Command.cpp	(revision 2921)
+++ /trunk/packages/vizservers/nanovis/Command.cpp	(revision 2922)
@@ -1670,5 +1670,5 @@
     }
     Rappture::Unirect2d data(1);
-    if (data.ParseBuffer(interp, buf) != TCL_OK) {
+    if (data.parseBuffer(interp, buf) != TCL_OK) {
 	return TCL_ERROR;
     }
@@ -2299,5 +2299,5 @@
     Rappture::Unirect2d *dataPtr = (Rappture::Unirect2d *)clientData;
 
-    return dataPtr->LoadData(interp, objc, objv);
+    return dataPtr->loadData(interp, objc, objv);
 }
 
@@ -2320,5 +2320,5 @@
     Rappture::Unirect3d *dataPtr = (Rappture::Unirect3d *)clientData;
 
-    return dataPtr->LoadData(interp, objc, objv);
+    return dataPtr->loadData(interp, objc, objv);
 }
 
Index: /trunk/packages/vizservers/nanovis/FlowCmd.cpp
===================================================================
--- /trunk/packages/vizservers/nanovis/FlowCmd.cpp	(revision 2921)
+++ /trunk/packages/vizservers/nanovis/FlowCmd.cpp	(revision 2922)
@@ -732,5 +732,5 @@
     char *bytes = (char *)buf.bytes();
     if ((length > 4) && (strncmp(bytes, "<DX>", 4) == 0)) {
-        if (!dataPtr->ImportDx(result, nComponents, length-4, bytes+4)) {
+        if (!dataPtr->importDx(result, nComponents, length-4, bytes+4)) {
             Tcl_AppendResult(interp, result.remark(), (char *)NULL);
             delete dataPtr;
@@ -738,5 +738,5 @@
         }
     } else if ((length > 10) && (strncmp(bytes, "unirect3d ", 10) == 0)) {
-        if (dataPtr->ParseBuffer(interp, buf) != TCL_OK) {
+        if (dataPtr->parseBuffer(interp, buf) != TCL_OK) {
             delete dataPtr;
             return TCL_ERROR;
@@ -745,13 +745,13 @@
         Rappture::Unirect2d *u2dPtr;
         u2dPtr = new Rappture::Unirect2d(nComponents);
-        if (u2dPtr->ParseBuffer(interp, buf) != TCL_OK) {
+        if (u2dPtr->parseBuffer(interp, buf) != TCL_OK) {
             delete u2dPtr;
             return TCL_ERROR;
         }
-        dataPtr->Convert(u2dPtr);
+        dataPtr->convert(u2dPtr);
         delete u2dPtr;
     } else {
         TRACE("header is %.14s\n", buf.bytes());
-        if (!dataPtr->ImportDx(result, nComponents, length, bytes)) {
+        if (!dataPtr->importDx(result, nComponents, length, bytes)) {
             Tcl_AppendResult(interp, result.remark(), (char *)NULL);
             delete dataPtr;
@@ -815,5 +815,5 @@
     char *bytes = (char *)buf.bytes();
     if ((length > 4) && (strncmp(bytes, "<DX>", 4) == 0)) {
-        if (!dataPtr->ImportDx(result, nComponents, length - 4, bytes + 4)) {
+        if (!dataPtr->importDx(result, nComponents, length - 4, bytes + 4)) {
             Tcl_AppendResult(interp, result.remark(), (char *)NULL);
             delete dataPtr;
@@ -821,5 +821,5 @@
         }
     } else if ((length > 10) && (strncmp(bytes, "unirect3d ", 10) == 0)) {
-        if (dataPtr->ParseBuffer(interp, buf) != TCL_OK) {
+        if (dataPtr->parseBuffer(interp, buf) != TCL_OK) {
             delete dataPtr;
             return TCL_ERROR;
@@ -828,13 +828,13 @@
         Rappture::Unirect2d *u2dPtr;
         u2dPtr = new Rappture::Unirect2d(nComponents);
-        if (u2dPtr->ParseBuffer(interp, buf) != TCL_OK) {
+        if (u2dPtr->parseBuffer(interp, buf) != TCL_OK) {
             delete u2dPtr;
             return TCL_ERROR;
         }
-        dataPtr->Convert(u2dPtr);
+        dataPtr->convert(u2dPtr);
         delete u2dPtr;
     } else {
         TRACE("header is %.14s\n", buf.bytes());
-        if (!dataPtr->ImportDx(result, nComponents, length, bytes)) {
+        if (!dataPtr->importDx(result, nComponents, length, bytes)) {
             Tcl_AppendResult(interp, result.remark(), (char *)NULL);
             delete dataPtr;
Index: /trunk/packages/vizservers/nanovis/Unirect.cpp
===================================================================
--- /trunk/packages/vizservers/nanovis/Unirect.cpp	(revision 2921)
+++ /trunk/packages/vizservers/nanovis/Unirect.cpp	(revision 2922)
@@ -41,5 +41,5 @@
 
 int
-Rappture::Unirect2d::ParseBuffer(Tcl_Interp *interp, Rappture::Buffer &buf)
+Rappture::Unirect2d::parseBuffer(Tcl_Interp *interp, Rappture::Buffer &buf)
 {
     Tcl_Obj *objPtr;
@@ -51,5 +51,5 @@
     }
     int result;
-    result = LoadData(interp, objc, objv);
+    result = loadData(interp, objc, objv);
     Tcl_DecrRefCount(objPtr);
     if ((result != TCL_OK) || (!isInitialized())) {
@@ -60,5 +60,5 @@
 
 int
-Rappture::Unirect3d::ParseBuffer(Tcl_Interp *interp, Rappture::Buffer &buf)
+Rappture::Unirect3d::parseBuffer(Tcl_Interp *interp, Rappture::Buffer &buf)
 {
     Tcl_Obj *objPtr;
@@ -70,5 +70,5 @@
     }
     int result;
-    result = LoadData(interp, objc, objv);
+    result = loadData(interp, objc, objv);
     Tcl_DecrRefCount(objPtr);
     if ((result != TCL_OK) || (!isInitialized())) {
@@ -79,5 +79,5 @@
 
 int 
-Rappture::Unirect3d::LoadData(Tcl_Interp *interp, int objc, 
+Rappture::Unirect3d::loadData(Tcl_Interp *interp, int objc, 
                               Tcl_Obj *const *objv)
 {
@@ -316,5 +316,5 @@
 
 int 
-Rappture::Unirect2d::LoadData(Tcl_Interp *interp, int objc, 
+Rappture::Unirect2d::loadData(Tcl_Interp *interp, int objc, 
                               Tcl_Obj *const *objv)
 {
@@ -491,5 +491,5 @@
 
 bool
-Rappture::Unirect3d::ImportDx(Rappture::Outcome &result, size_t nComponents,
+Rappture::Unirect3d::importDx(Rappture::Outcome &result, size_t nComponents,
                               size_t length, char *string) 
 {
@@ -636,5 +636,5 @@
 
 bool
-Rappture::Unirect3d::Resample(Rappture::Outcome &result, size_t nSamples)
+Rappture::Unirect3d::resample(Rappture::Outcome &result, size_t nSamples)
 {
     Rappture::Mesh1D xgrid(_xMin, _xMax, _xNum);
@@ -714,8 +714,7 @@
 
 void
-Rappture::Unirect3d::GetVectorRange()
+Rappture::Unirect3d::getVectorRange()
 {
     assert(_nComponents == 3);
-    TRACE("GetVectorRange\n");
     _magMax = -DBL_MAX, _magMin = DBL_MAX;
     size_t i;
@@ -735,8 +734,9 @@
         }
     }
+    TRACE("GetVectorRange %g %g\n", _magMin, _magMax);
 }
 
 bool 
-Rappture::Unirect3d::Convert(Rappture::Unirect2d *dataPtr)
+Rappture::Unirect3d::convert(Rappture::Unirect2d *dataPtr)
 {
     _initialized = false;
Index: /trunk/packages/vizservers/nanovis/Unirect.h
===================================================================
--- /trunk/packages/vizservers/nanovis/Unirect.h	(revision 2921)
+++ /trunk/packages/vizservers/nanovis/Unirect.h	(revision 2922)
@@ -1,5 +1,5 @@
 /* -*- mode: c++; c-basic-offset: 4; indent-tabs-mode: nil -*- */
-#ifndef _UNIRECT_H
-#define _UNIRECT_H
+#ifndef UNIRECT_H
+#define UNIRECT_H
 
 #include <float.h>
@@ -55,17 +55,17 @@
         if (_values != NULL) {
             free(_values);
-	}
-	if (_xUnits != NULL) {
+        }
+        if (_xUnits != NULL) {
             free(_xUnits);
-	}
-	if (_yUnits != NULL) {
+        }
+        if (_yUnits != NULL) {
             free(_yUnits);
-	}
-	if (_zUnits != NULL) {
+        }
+        if (_zUnits != NULL) {
             free(_zUnits);
-	}
-	if (_vUnits != NULL) {
+        }
+        if (_vUnits != NULL) {
             free(_vUnits);
-	}
+        }
     }
 
@@ -177,5 +177,5 @@
     {
         if (_magMin == DBL_MAX) {
-            GetVectorRange();
+            getVectorRange();
         }
         return _magMin;
@@ -185,5 +185,5 @@
     {
         if (_magMax == -DBL_MAX) {
-            GetVectorRange();
+            getVectorRange();
         }
         return _magMax;
@@ -204,14 +204,14 @@
     }
 
-    int LoadData(Tcl_Interp *interp, int objc, Tcl_Obj *const *objv);
-
-    int ParseBuffer(Tcl_Interp *interp, Rappture::Buffer &buf);
-
-    bool ImportDx(Rappture::Outcome &result, size_t nComponents, 
-		  size_t length, char *string);
-
-    bool Convert(Unirect2d *dataPtr);
-
-    bool Resample(Rappture::Outcome &context, size_t nSamples = 30);
+    int loadData(Tcl_Interp *interp, int objc, Tcl_Obj *const *objv);
+
+    int parseBuffer(Tcl_Interp *interp, Rappture::Buffer &buf);
+
+    bool importDx(Rappture::Outcome &result, size_t nComponents, 
+                  size_t length, char *string);
+
+    bool convert(Unirect2d *dataPtr);
+
+    bool resample(Rappture::Outcome &context, size_t nSamples = 30);
 
     bool isInitialized()
@@ -221,5 +221,5 @@
 
 private:
-    void GetVectorRange();
+    void getVectorRange();
 
     size_t _xNum, _yNum, _zNum;
@@ -230,6 +230,6 @@
     float _yValueMin, _yValueMax;
     float _zValueMin, _zValueMax;
-    double _magMin, _magMax;		/* Range of magnitudes of vector
-					 * data. */
+    double _magMin, _magMax;                /* Range of magnitudes of vector
+                                         * data. */
     char *_xUnits;
     char *_yUnits;
@@ -258,11 +258,11 @@
         if (_values != NULL) {
             free(_values);
-	}
+        }
         if (_xUnits != NULL) {
             free(_xUnits);
-	}
+        }
         if (_yUnits != NULL) {
             free(_yUnits);
-	}
+        }
         if (_vUnits != NULL) {
             free(_vUnits);
@@ -359,8 +359,8 @@
     }
 
-    int LoadData(Tcl_Interp *interp, int objc, Tcl_Obj *const *objv);
-    
-    int ParseBuffer(Tcl_Interp *interp, Rappture::Buffer &buf);
-    
+    int loadData(Tcl_Interp *interp, int objc, Tcl_Obj *const *objv);
+
+    int parseBuffer(Tcl_Interp *interp, Rappture::Buffer &buf);
+
     bool isInitialized()
     {
@@ -389,3 +389,2 @@
 
 #endif
-